"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var unist_util_visit_1 = __importDefault(require("unist-util-visit"));
exports.default = (function (_a, pluginOptions) {
    var markdownAST = _a.markdownAST;
    if (pluginOptions === void 0) { pluginOptions = {}; }
    var acronyms = pluginOptions.acronyms;
    if (!acronyms)
        return markdownAST;
    var acronymsRegExp = new RegExp("\\b(" + Object.keys(acronyms).join('|') + ")\\b", 'g');
    unist_util_visit_1.default(markdownAST, 'text', function (node, index, parent) {
        var _a;
        if (node.value && typeof node.value === 'string') {
            var newNodes = node.value.split(acronymsRegExp).map(function (value) {
                var acronymTitle = acronyms[value];
                return acronymTitle
                    ? {
                        type: 'html',
                        value: "<acronym title=\"" + acronymTitle + "\">" + value + "</acronym>",
                    }
                    : {
                        type: 'text',
                        value: value,
                    };
            });
            (_a = parent.children).splice.apply(_a, __spreadArrays([index, 1], newNodes));
            return index + newNodes.length;
        }
        return index + 1;
    });
    return markdownAST;
});
